xine-lib: xine-lib-1.2.13/src/demuxers/demux_snd.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_snd.c File Reference
`#include <stdio.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <ctype.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/demux.h>`
`#include <xine/buffer.h>`
`#include "bswap.h"`
`#include "group_audio.h"`

## Data Structures
struct | demux_snd_t

## Macros
#define | SND_HEADER_SIZE 24
#define | PCM_BLOCK_ALIGN 1024

## Functions
static int | probe_snd_file (input_plugin_t *input)
static int | open_snd_file (demux_snd_t *this)
static int | demux_snd_send_chunk (demux_plugin_t *this_gen)
static void | demux_snd_send_headers (demux_plugin_t *this_gen)
static int | demux_snd_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_snd_get_status (demux_plugin_t *this_gen)
static int | demux_snd_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_snd_get_capabilities (demux_plugin_t *this_gen)
static int | demux_snd_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_snd_init_plugin (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ PCM_BLOCK_ALIGN

#define PCM_BLOCK_ALIGN 1024

Referenced by open_snd_file().

## ◆ SND_HEADER_SIZE

#define SND_HEADER_SIZE 24

Referenced by open_snd_file().

## Function Documentation

## ◆ demux_snd_get_capabilities()

static uint32_t demux_snd_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_snd_get_optional_data()

static int demux_snd_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_snd_get_status()

static int demux_snd_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_snd_get_stream_length()

static int demux_snd_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_snd_init_plugin()

void * demux_snd_init_plugin | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ demux_snd_seek()

static int demux_snd_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References _x_demux_flush_engine(), DEMUX_FINISHED, DEMUX_OK, input(), and INPUT_IS_SEEKABLE.

Referenced by open_plugin().

## ◆ demux_snd_send_chunk()

static int demux_snd_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_newpts(), BUF_FLAG_FRAME_END, BUF_FLAG_SEEK, buf_element_s::content, buf_element_s::decoder_flags, DEMUX_FINISHED, buf_element_s::extra_info, buf_element_s::free_buffer, input(), extra_info_s::input_normpos, extra_info_s::input_time, buf_element_s::max_size, NULL, buf_element_s::pts, buf_element_s::size, and buf_element_s::type.

Referenced by open_plugin().

## ◆ demux_snd_send_headers()

static void demux_snd_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), BUF_FLAG_FRAME_END, BUF_FLAG_HEADER, BUF_FLAG_STDHEADER, buf_element_s::decoder_flags, buf_element_s::decoder_info, DEMUX_OK, buf_element_s::size, buf_element_s::type, XINE_STREAM_INFO_AUDIO_BITS, XINE_STREAM_INFO_AUDIO_CHANNELS, XINE_STREAM_INFO_AUDIO_SAMPLERATE, XINE_STREAM_INFO_HAS_AUDIO, and XINE_STREAM_INFO_HAS_VIDEO.

Referenced by open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_snd_get_capabilities(), demux_snd_get_optional_data(), demux_snd_get_status(), demux_snd_get_stream_length(), demux_snd_seek(), demux_snd_send_chunk(), demux_snd_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, open_snd_file(), probe_snd_file(), and input_plugin_s::seek.

Referenced by demux_snd_init_plugin().

## ◆ open_snd_file()

static int open_snd_file | ( | demux_snd_t * | this | ) |
| static

References _, _X_BE_32, _x_demux_read_header(), BUF_AUDIO_ALAW, BUF_AUDIO_LPCM_BE, BUF_AUDIO_MULAW, input(), PCM_BLOCK_ALIGN, SND_HEADER_SIZE, xine_log(), and XINE_LOG_MSG.

Referenced by open_plugin().

## ◆ probe_snd_file()

static int probe_snd_file | ( | input_plugin_t * | input | ) |
| static

References _x_demux_read_header(), _x_is_fourcc(), fourcc, and input().

Referenced by open_plugin().